<?php

function peachpay_ajax_create_order() {
    if ( WC()->cart->is_empty() ) {
        wp_send_json_error( 'Empty cart' );
    }
    if ( ! defined( 'WOOCOMMERCE_CHECKOUT' ) ) {
        define( 'WOOCOMMERCE_CHECKOUT', true );
    }
    WC()->checkout()->process_checkout();
    die( 0 );
}

function peachpay_add_gateway_class( $gateways ) {
    $gateways[] = 'WC_PeachPay_Gateway';
    return $gateways;
}
add_filter( 'woocommerce_payment_gateways', 'peachpay_add_gateway_class' );

function peachpay_init_gateway_class() {
    class WC_PeachPay_Gateway extends WC_Payment_Gateway {
        public function __construct() {
            $this->id = 'peachpay'; // payment gateway plugin ID
            $this->title = 'PeachPay';
            $this->has_fields = false; // in case you need a custom credit card form
            $this->method_title = 'PeachPay';
            $this->method_description = 'Use the other <a href="http://localhost:8000/wp-admin/admin.php?page=peachpay">PeachPay settings</a>'; // will be displayed on the options page
            // gateways can support subscriptions, refunds, saved payment methods,
            // but in this tutorial we begin with simple payments
            $this->supports = array( 'products' );
        }

        public function init_form_fields(){}
        public function payment_fields() {}
        // Custom CSS and JS, in most cases required only when you decided to go with a custom credit card form
        public function payment_scripts() {}

        public function validate_fields() {
            // TODO: order validation
            // if( empty( $_POST[ 'billing_first_name' ]) ) {
            //     wc_add_notice( 'First name is required!', 'error' );
            //     return false;
            // }
            return true;
        }

        public function process_payment( $order_id ) {
            global $woocommerce;
            $order = wc_get_order( $order_id );
            // Payment is processed via our own API right now
            $order->payment_complete();
            return array(
                'result' => 'success',
                'redirect' => $this->get_return_url( $order ),
                'orderID' => $order_id
            );
        }

        public function webhook() {}
    }
}
add_action( 'plugins_loaded', 'peachpay_init_gateway_class' );
