document.addEventListener('DOMContentLoaded', pp_placeButtonProductPage);
// We use 'load' here because the mini carts often are added by third-party scripts,
// so we have to wait for the scripts to load and not just the DOM content
window.addEventListener('load', pp_placeButtonMiniCart);

function pp_placeButtonProductPage() {
	if (php_data.is_cart_page || location.href.includes('cart')) {
		// Cart pages can have upsells products that appear as a single product.
		// Don't add the PeachPay button for these.
		return;
	}

	if (php_data.is_category_page) {
		return;
	}

	if (location.hostname === 'www.beyourbag.it') {
		// We cannot have PeachPay on the product page for this merchant until
		// we add compatibility for WooCommerce Attribute Swatches
		return;
	}

	let addToCartForm = document.querySelector('form.cart');

	if (location.hostname === 'olybird.com' && peachpay_isMobile()) {
		addToCartForm = document.querySelectorAll('form.cart')[1];
	}

	if (addToCartForm === null && location.hostname === 'www.jogiachamasalo.com') {
		addToCartForm = document.querySelector('div.cart');
	}

	if (addToCartForm !== null) {
		// Add the PeachPay button to the screen
		const skregearMobile = location.hostname === 'skregear.com' && peachpay_isMobile();
		const position = skregearMobile ? 'beforeend' : 'afterend';
		addToCartForm.insertAdjacentHTML(position, pp_peachpayButton);

		// Add the checkout window iframe to the page
		document.querySelector('body').insertAdjacentHTML('beforeend', pp_checkoutForm);

		const full = php_data.button_position_product_page === 'full';
		const width = full ? '100%' : ((php_data.button_width_product_page || '220') + 'px');
		init({
			width,
			position: php_data.button_position_product_page,
		});
	}

	const isBrancalmelmeladaLandingPage =
		location.href.includes('landing_venta_5kgsnaranjas') ||
		location.href.includes('mermelada-mandarina-brancal') ||
		location.href.includes('licor-de-mandarina-brancal');

	if (addToCartForm === null && location.hostname === 'www.brancalmelmelada.com' && isBrancalmelmeladaLandingPage) {
		document.querySelector('body').insertAdjacentHTML('beforeend', pp_peachpayButton);
		document.querySelector('#pp-button-container').style.display = 'none';
		document.querySelector('body').insertAdjacentHTML('beforeend', pp_checkoutForm);
		const full = php_data.button_position_product_page === 'full';
		const width = full ? '100%' : ((php_data.button_width_product_page || '220') + 'px');
		init({
			width,
			position: php_data.button_position_product_page,
		});
		const links = document.querySelectorAll('a[href^="https://www.brancalmelmelada.com/plataforma/checkout/?add-to-cart="]');
		if (links) {
			links.forEach(a => {
				a.target = '';
				a.href = 'javascript:';
				a.addEventListener('click', () => {
					showLoadingSpinner();
					sendButtonClickedMessage();
				});
			});
		}
	}
}

function pp_placeButtonMiniCart() {
	const miniCartButtons = document.querySelector('.woocommerce-mini-cart__buttons');

	if (!miniCartButtons) {
		return;
	}

	if (!document.querySelector('#pp-modal-overlay')) {
		document.querySelector('body').insertAdjacentHTML('beforeend', pp_checkoutForm);
	}

	miniCartButtons.insertAdjacentHTML('beforeend', pp_peachpayButtonMiniCart);

	if (location.hostname === 'skregear.com') {
		const miniButton = document.querySelector('#pp-button-mini');
		miniButton.style.padding = '3px';
		miniButton.style.cssText += 'text-transform: uppercase !important;';
	}

	init({
		position: php_data.button_position_product_page,
		isMiniCart: true,
	});
}
